/*
 * Test4a.c -- Create and execute three threads 
 */
 
#include <stdlib.h>
#include <stdio.h>
#include "pcthread.h"

static pcthread_t       child_th1, child_th2;
static pcthread_attr_t  th_attr;

static void say_hello( void );
static void compute( void );

static int    dummy;
static unsigned long bigsum = 0;

main()
{

    /*
     * Create a thread attributes object (actually a handle to the object)
     * with which we will create a couple of threads with a very small
     * quantum.  This will lead to lots of clock handler involvement.,
     */
     
    (void) pcthread_attr_create( (pcthread_attr_t *) &th_attr);
    (void) pcthread_attr_setquantum_ns( (pcthread_attr_t *) &th_attr, 1 );
    (void) pcthread_attr_setsched((pcthread_attr_t *)&th_attr, round_robin_c );
    
    /*
     * Create the compute thread
     */     

    (void) pcthread_create(  (pcthread_t *) &child_th2, 
                             th_attr,
                             (pcthread_action_t) compute,
                             (pcthread_addr_t *) &dummy );

    /*
     * Now the "say hello" thread
     */
     
    (void) pcthread_create(  (pcthread_t *) &child_th1, 
                             th_attr,
                             (pcthread_action_t) say_hello,
                             (pcthread_addr_t *) &dummy );

    return;
}

void
say_hello()
{
    int  ctx;
    
    ctx = pcthread_disable_preemption_ns();
    printf("Hello world\n");
    pcthread_enable_preemption_ns( ctx );
}

void
compute()
{
    unsigned ticks = 0, i, j;
    unsigned long sum = 0;    

    for(i = 0; i < 30000; i++ )
         for(j = 0; j < 10000; j++ )
         {
              sum += j + i;
              if( sum++ == 80000 )
              {
                   sum = 0;
                   ticks += 1;
              }
         }         

    bigsum = sum;
}