/*
 * Test7.c    --   A test of pcthread_join().
 */
 
#include <stdlib.h>
#include <stdio.h>
#include "pcthread.h"

static pcthread_t  hello_th, compute_th;
static pcthread_attr_t  th_attr_handle;

void say_hello( void );
pcthread_t *compute( void );
static int arg;

main()
{
    (void) pcthread_attr_create( (pcthread_attr_t *) &th_attr_handle );

    (void) pcthread_attr_setstacksize( 
                   (pcthread_attr_t *) &th_attr_handle, 1024 );

    (void) pcthread_create(  (pcthread_t *) &hello_th,
                             th_attr_handle, 
                             (pcthread_action_t) say_hello,
                             (pcthread_addr_t *) &arg);


    (void) pcthread_attr_setstacksize( 
              (pcthread_attr_t *) &th_attr_handle, 512 );

    (void) pcthread_create(  (pcthread_t *) &compute_th,
                             th_attr_handle, 
                             (pcthread_action_t) compute,
                             (pcthread_addr_t *) &arg );

    pcthread_yield();

    return;
}

void
say_hello()
{
    pcthread_t *th_handle;
    int  ctx;
    
    (void) pcthread_join( &compute_th, (pcthread_addr_t *) &th_handle );

    ctx = pcthread_disable_preemption_ns();
    printf("Retrieved handle to thread %u\n", th_handle->object_id );
    pcthread_enable_preemption_ns( ctx );
}

pcthread_t *
compute()
{
    int i, foo = 0, bar = 0;
    
    pcthread_t *th_handle;
 
    for(i = 0; i < 30000; i++ )
    {
         foo += i;
         if( foo % 100 == 0 )
              bar += 1;
    }
    
    th_handle = pcthread_self();
        
    return( th_handle );
}