/*
 * Test9.c    --   A test of pcthread_join() and pcthread_exit()
 */
 
#include <stdlib.h>
#include <stdio.h>
#include "pcthread.h"

#define THREADS 3
static pcthread_t       hello_th[THREADS], compute_th;
static pcthread_attr_t  th_attr_handle;

void say_hello( void );
int compute( void );
static int arg;

main()
{
    int i, status;

    status = pcthread_attr_create( (pcthread_attr_t *) &th_attr_handle );

    status = pcthread_attr_setstacksize( 
                   (pcthread_attr_t *) &th_attr_handle, 1024 );

    for(i = 0; i < THREADS; i++ )
         status = pcthread_create(  (pcthread_t *) &hello_th[i],
                                     th_attr_handle, 
                                     (pcthread_action_t) say_hello,
                                     (pcthread_addr_t *) &arg);


    status = pcthread_attr_setstacksize( 
              (pcthread_attr_t *) &th_attr_handle, 512 );

    status = pcthread_create(  (pcthread_t *) &compute_th,
                             th_attr_handle, 
                             (pcthread_action_t) compute,
                             (pcthread_addr_t *) &arg );

    pcthread_yield();

    return;
}

int
compute()
{
    int bar;
    
    bar = -1;

    pcthread_exit( (pcthread_addr_t) bar );
    return( bar );
}

void
say_hello()
{
    int  foo;
    int  ctx;
    
    (void) pcthread_join( (pcthread_t *) &compute_th, 
                          (pcthread_addr_t *) &foo );

    ctx = pcthread_disable_preemption_ns();
    printf("foo = %d\n", foo );
    pcthread_enable_preemption_ns( ctx );
}